<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
        PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
        "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<!-- namespace：命名空间，用于隔离sql，还有一个很重要的作用，后面会讲 -->
<mapper namespace="com.xiqiart.dao.OrderDao">

    <!--
        动态代理的开发规范
            1: 映射文件的namespace必须等于接口的全路径名称
            2: 映射文件的sql唯一标示,必须等于接口的方法名称
            3: 映射文件的parameterType必须等于接口方法的参数类型
            4: 映射文件resultType必须等于接口方法的返回类型
     -->

    <select id="queryUserOrders" resultType="com.xiqiart.entity.Order">
        SELECT *
        FROM tb_order
        WHERE user_id=#{userId}
    </select>

    <select id="orderTabQuery" resultType="com.xiqiart.entity.Order">
        SELECT *
        FROM tb_order
        WHERE user_id=#{userId} AND order_status=#{orderStatus}
        Order by id desc
    </select>

    <select id="orderQuery" resultType="com.xiqiart.entity.Order">
        SELECT *
        FROM tb_order
        WHERE user_id=#{userId} and order_no=#{orderNo}
        Order by id desc
    </select>

    <select id="querySingleOrder" resultType="com.xiqiart.entity.Order">
        SELECT *
        FROM tb_order
        WHERE order_no=#{orderNo}
    </select>


    <select id="orderRoomQuery" resultType="com.xiqiart.entity.OrderRoom">
        SELECT *
        FROM tb_order_room
        WHERE order_no=#{orderNo}
    </select>

    <select id="queryOrderList" resultType="com.xiqiart.entity.Order">
        SELECT *
        FROM tb_order
        WHERE order_status > 1
        <if test="orderNo!=''"> AND order_no=#{orderNo}</if>
        <if test="contactPhone!=''">AND contact_phone=#{contactPhone}</if>
        ORDER BY ID DESC
        LIMIT #{offset},#{pageSize}

    </select>

    <select id="queryAllOrders" resultType="com.xiqiart.web.model.OrderRoomInfo">
        SELECT o.order_no, o.order_status, o.course_name, o.contact_name, o.contact_phone, o.day_count, o.amount, o.arrive_date,o.create_time, r.room_type_name, r.guest_name
        FROM tb_order o
        LEFT JOIN tb_order_room r ON o.order_no = r.order_no
        WHERE o.order_status > 1
        ORDER BY o.id
    </select>

    <select id="queryOrderListCount" resultType="java.lang.Integer">
        SELECT COUNT(1)
        FROM tb_order
        WHERE order_status > 1
        <if test="orderNo!=''"> AND order_no=#{orderNo}</if>
        <if test="contactPhone!=''"> AND contact_phone=#{contactPhone}</if>
    </select>


    <update id="updateOrder" parameterType="com.xiqiart.entity.Order">
        UPDATE  tb_order
        <set>
            <if test="orderStatus > 0">order_status=#{orderStatus},</if>
            <if test="lastEditTime!=null">last_edit_time=#{lastEditTime},</if>
        </set>
        WHERE user_id=#{userId} AND order_no=#{orderNo}
    </update>

    <update id="adminUpdateOrder" parameterType="com.xiqiart.entity.Order">
        UPDATE  tb_order
        <set>
            <if test="orderStatus > 0">order_status=#{orderStatus},</if>
            <if test="lastEditTime!=null">last_edit_time=#{lastEditTime},</if>
        </set>
        WHERE order_no=#{orderNo}
    </update>

    <insert id="addOrder" useGeneratedKeys="true" keyProperty="id" parameterType="com.xiqiart.entity.Order">
        INSERT INTO
        tb_order
        (order_no, user_id, course_id, org_name, attendance_count, course_name, course_count,contact_name, contact_phone,arrive_date,
        day_count,course_amount, amount, order_status, create_time, last_edit_time, order_comment)
        VALUES
        (#{orderNo},#{userId},#{courseId},#{orgName},#{attendanceCount},#{courseName}, #{courseCount}, #{contactName}, #{contactPhone},
        #{arriveDate},#{dayCount},#{courseAmount},#{amount},#{orderStatus},#{createTime},#{lastEditTime}, #{orderComment})
    </insert>

    <insert id="addOrderRoom" useGeneratedKeys="true" keyProperty="id"
            keyColumn="id" parameterType="com.xiqiart.entity.OrderRoom">
        INSERT INTO
        tb_order_room
        (room_id, room_type_name, guest_name, order_no, amount, create_time, last_edit_time)
        VALUES
        (#{roomId},#{roomTypeName},#{guestName},#{orderNo},#{amount},#{createTime},#{lastEditTime})
    </insert>

</mapper>